#ifndef _CONFIG_H_
#define _CONFIG_H_

#include <pcre.h>


#define CODES_EVENT_VARIABLE 3  //  ,    
#define CODES_EVENT_LENGTH   16 //      
#define CODES_LAYOUT_NUMBER  10 //        

#define REGEXP_COMPILE_SIZE 4096

#define CONFIG_DEVICE_TYPE_KEYBOARD 0
#define CONFIG_DEVICE_TYPE_JOYSTICK 1

#define CONFIG_SWITCH_METHOD_CYCLIC 0
#define CONFIG_SWITCH_METHOD_DIRECT 1


struct REGEXPDATA
{
 char regexp[250]; //   
 char regexpCompile[REGEXP_COMPILE_SIZE]; //    
};

struct CMDDATA
{
 char cmdText[250]; //  
};

class Config
{
public:
 Config();
 ~Config();

 void init(void);
 bool readFile(char *fileName);
 void createStandartConfig();
 void print(void);

 //     
 char *getInputDevice();
 int getDeviceType();
 int getNumberOfLayout();
 int getSwitchMethod();
 char *getEventFilter();
 char *getEventFilterCompile();
 char *getSequence(int n);
 char *getSequenceCompile(int n);
 char *getCommand(int n);

 char *getUserDirectory();
 char *getUserName();

private:

 // ,     
 char inputDevice[250]; //     
 int deviceType; //  
 int numberOfLayout; //  
 int switchMethod; //  
 REGEXPDATA eventFilter; //   
 REGEXPDATA sequences[CODES_LAYOUT_NUMBER]; //    
 CMDDATA  commands[CODES_LAYOUT_NUMBER]; //   

 //  ,    
 char configFileName[250];

 void regexpCompiling(char *regexpText, char *regexpCompileData);
 void createDirIfNotExists(char *dirName, char *userName);
};

#endif // _CONFIG_H_
