#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "KeyLayout.h"


KeyLayout::KeyLayout()
{
 init();
}


KeyLayout::~KeyLayout()
{

}


void KeyLayout::init() 
{
 //    
 display = XOpenDisplay(NULL);

 if( display == NULL ) 
  {
   printf("Error XOpenDisplay");
   exit(1);
  }
}


//   ,     
int KeyLayout::getActiveGroup() 
{
 XkbStateRec state[1];
 memset(state, 0, sizeof(state));

 XkbGetState(display, XkbUseCoreKbd, state);

 return state->group;
}


//  
// dpy -  
// group -   (   
//            ,   0
int KeyLayout::setActiveGroup(int group) 
{
 //     
 XkbLockGroup( display, XkbUseCoreKbd, group );

 //  XkbGetState()   ,
 //       
 XkbStateRec state[1];
 memset(state, 0, sizeof(state));
 XkbGetState(display, XkbUseCoreKbd, state);
}


//     
//  **names   
//    
int KeyLayout::getLayouts(char **names) 
{
 XkbDescRec desc[1];
 int gc;
 memset(desc, 0, sizeof(desc));
 desc->device_spec = XkbUseCoreKbd;
 XkbGetControls(display, XkbGroupsWrapMask, desc);
 XkbGetNames(display, XkbGroupNamesMask, desc);
 XGetAtomNames(display, desc->names->groups, gc = desc->ctrls->num_groups, names);
 XkbFreeControls(desc, XkbGroupsWrapMask, True);
 XkbFreeNames(desc, XkbGroupNamesMask, True);
 return gc;
}


//     
//      
//    
void KeyLayout::freeLayouts(char **names, int gc) 
{
 for (; gc--; ++names)
  if (*names) 
   {
    XFree(*names);
    *names = NULL;
   }
}


void KeyLayout::print() 
{
 //   
 char *names[XkbNumKbdGroups];

 //    
 int gc=getLayouts(names);

 //    
 int g=getActiveGroup();

 //     
 for(int i = 0; i < gc; i++)
  printf("%d - %s %s\n", i, names[i], i == g ? "(Active)" : "");
 
 //    
 freeLayouts(names, gc);
}


//    
int KeyLayout::getLayout() 
{
 return getActiveGroup();
}


//   
void KeyLayout::setLayout(int n)
{
 setActiveGroup(n);
}


//  
int KeyLayout::getLayoutNumber()
{
 XkbDescRec desc[1];

 memset(desc, 0, sizeof(desc));
 desc->device_spec = XkbUseCoreKbd;
 XkbGetControls(display, XkbGroupsWrapMask, desc);

 return desc->ctrls->num_groups;
}
